# sorry this file is such a mess // JCZ

library(data.table)
library(rjson)
library(Hmisc)
library(tidyr)
library(ggplot2)
library(gridExtra)
library(MASS)

# import json, convert to data.table
# what a mess...

json_data<-fromJSON(file="ad_graphs_usf_persev.json")

unlister <- function(x) {
    x[sapply(x, is.null)] <- NA
    unlist(x)
}

json_ad <- lapply(json_data$ad, unlister)
json_nc <- lapply(json_data$nc, unlister)
json_ad_shuffled <- lapply(json_data$ad_shuffled, unlister)
json_nc_shuffled <- lapply(json_data$nc_shuffled, unlister)

ad_dt <- data.table(t(do.call("rbind", json_ad)))
nc_dt <- data.table(t(do.call("rbind", json_nc)))
ad_shuffled_dt <- data.table(t(do.call("rbind", json_ad_shuffled)))
nc_shuffled_dt <- data.table(t(do.call("rbind", json_nc_shuffled)))

ad_dt[,group:="ProbAD"]
ad_shuffled_dt[,group:="ProbAD"]
nc_dt[,group:="NC"]
nc_shuffled_dt[,group:="NC"]

ad_dt[,nettype:="unshuffled"]
ad_shuffled_dt[,nettype:="shuffled"]
nc_dt[,nettype:="unshuffled"]
nc_shuffled_dt[,nettype:="shuffled"]

dat <- rbind(ad_dt, nc_dt, ad_shuffled_dt, nc_shuffled_dt)
dat[,id:=as.integer(subs)]
dat[,subs:=NULL]

fluency_dat <- fread('ucsd_fluency_for_snafu_20180518.csv')
fluency_dat <- fluency_dat[,.(id, group, SEX, EDUC, DRS, MMSE, listnum)]
fluency_dat <- merge(fluency_dat[,.N,keyby=.(id,group,listnum)],fluency_dat)    # add num animals per list
fluency_dat <- fluency_dat[MMSE > 0]    # remove MMSE coded < 0 (not real scores)
fluency_dat <- fluency_dat[group=="ProbAD" | group=="NC"]
fluency_dat <- fluency_dat[,.(numtotal=mean(N),sex=mean(SEX),educ=mean(EDUC),drs=mean(DRS),mmse=mean(MMSE)),keyby=.(id,group)]

dat <- merge(fluency_dat, dat, by=c("id","group"))

# why are these all the wrong type...
dat[,clustering:=as.double(clustering)]
dat[,number_of_nodes:=as.integer(number_of_nodes)]
dat[,density:=as.double(density)]
dat[,median_degree:=as.integer(median_degree)]
dat[,persev_data:=as.double(persev_data)]
dat[,mean_degree:=as.double(mean_degree)]
dat[,numlists:=as.integer(numlists)]
dat[,persev_params:=as.double(persev_params)]
dat[,spl:=as.double(spl)]
dat[,diameter:=as.double(diameter)]
dat[,smallworld:=as.double(smallworld)]

dat <- dcast(dat, id + group + sex + educ + drs + mmse + number_of_nodes + numlists + numtotal ~ nettype,value.var=c("density","clustering","mean_degree","median_degree","persev_params","diameter","spl","persev_data","smallworld"))

# look only at networks generated from >= 3 lists
dat <- dat[numlists >= 3]

# means
dat[,lapply(.SD,mean),keyby=group]

# there should be only one persev_data (same for shuffled/unshuffled) but because of floating point error there are two
# this resolves the issue
dat[,persev_data := persev_data_unshuffled]
dat[,persev_data_shuffled := NULL]
dat[,persev_data_unshuffled := NULL]

# compute difference scores for network properties only
dat[,density_diff := density_unshuffled - density_shuffled]
dat[,mean_degree_diff := mean_degree_unshuffled - mean_degree_shuffled]
dat[,median_degree_diff := median_degree_unshuffled - median_degree_shuffled]
dat[,clustering_diff := clustering_unshuffled - clustering_shuffled]
dat[,spl_diff := spl_unshuffled - spl_shuffled]
dat[,diameter_diff := diameter_unshuffled - diameter_shuffled]
dat[,smallworld_diff := smallworld_unshuffled - smallworld_shuffled]
dat[,persev_params_diff:=persev_params_unshuffled-persev_params_shuffled] # unused

# compare raw network statistics
t.test(dat[group=="ProbAD",number_of_nodes],dat[group=="NC",number_of_nodes])                   # yes!
t.test(dat[group=="ProbAD",persev_params_unshuffled],dat[group=="NC",persev_params_unshuffled]) # yes!
t.test(dat[group=="ProbAD",persev_data],dat[group=="NC",persev_data])                           # yes!

t.test(dat[group=="ProbAD",density_unshuffled],dat[group=="NC",density_unshuffled])             # yes!
t.test(dat[group=="ProbAD",mean_degree_unshuffled],dat[group=="NC",mean_degree_unshuffled],var.equal=TRUE)     # yes!
t.test(dat[group=="ProbAD",median_degree_unshuffled],dat[group=="NC",median_degree_unshuffled],var.equal=TRUE) # no.
t.test(dat[group=="ProbAD",clustering_unshuffled],dat[group=="NC",clustering_unshuffled])       # no.
t.test(dat[group=="ProbAD",spl_unshuffled],dat[group=="NC",spl_unshuffled],var.equal=TRUE)                     # yes!

t.test(dat[group=="ProbAD",numtotal],dat[group=="NC",numtotal])                   # yes!
t.test(dat[group=="ProbAD",mmse],dat[group=="NC",mmse])                   # yes!
t.test(dat[group=="ProbAD",diameter_unshuffled],dat[group=="NC",diameter_unshuffled],var.equal=TRUE)                     # yes!

# compare delta network statistics
t.test(dat[group=="ProbAD",density_diff],dat[group=="NC",density_diff])                         # no.
t.test(dat[group=="ProbAD",mean_degree_diff],dat[group=="NC",mean_degree_diff])                 # yes!
t.test(dat[group=="ProbAD",median_degree_diff],dat[group=="NC",median_degree_diff])             # yes!
t.test(dat[group=="ProbAD",clustering_diff],dat[group=="NC",clustering_diff])                   # no.
t.test(dat[group=="ProbAD",spl_diff],dat[group=="NC",spl_diff],var.equal=TRUE)                                 # yes!
t.test(dat[group=="ProbAD",diameter_diff],dat[group=="NC",diameter_diff],var.equal=TRUE)                     # yes!

# sig correlated with mmse (mini mental state exam)?
rcorr(dat[,mmse],dat[,number_of_nodes])          # YES
rcorr(dat[,mmse],dat[,persev_data])              # YES
rcorr(dat[,mmse],dat[,persev_params_unshuffled]) # YES      ** i don't think it makes sense to compute persev_data_shuffled but we can discuss
rcorr(dat[,mmse],dat[,density_diff])             # NO
rcorr(dat[,mmse],dat[,mean_degree_diff])         # YES
rcorr(dat[,mmse],dat[,median_degree_diff])       # NO
rcorr(dat[,mmse],dat[,clustering_diff])          # NO
rcorr(dat[,mmse],dat[,spl_diff])                 # YES

# sig correlated with drs (dementia rating scale)?
rcorr(dat[,drs],dat[,number_of_nodes])          # YES
rcorr(dat[,drs],dat[,persev_data])              # YES
rcorr(dat[,drs],dat[,persev_params_unshuffled]) # YES 
rcorr(dat[,drs],dat[,density_diff])             # NO
rcorr(dat[,drs],dat[,mean_degree_diff])         # YES
rcorr(dat[,drs],dat[,median_degree_diff])       # YES
rcorr(dat[,drs],dat[,clustering_diff])          # NO
rcorr(dat[,drs],dat[,spl_diff])                 # YES

ggplot(dat,aes(x=spl,y=number_of_nodes,group=group,color=group)) + geom_point(stat="identity")

# linear/logistic regression models
dat[,bindiag:=0]
dat[group=="ProbAD",bindiag:=1]

### HELPER FUNCTIONS FOR PREDICTING DIAGNOSES

# calculate f-score from 2x2 table
fscore <- function(tab) {
    truepos <- tab[bindiag==1 & pred==1][,N]
    falsepos <- tab[bindiag==0 & pred==1][,N]
    falseneg <- tab[bindiag==1 & pred==0][,N]
    if (length(truepos) == 0) { truepos<-0 }
    if (length(falsepos) == 0) { falsepos<-0 }
    if (length(falseneg) == 0) { falseneg<-0 }
    sdt_precision <- truepos / (truepos+falsepos)
    sdt_recall <- truepos / (truepos+falseneg)
    f1 <- 2 * ((sdt_precision * sdt_recall) / (sdt_precision + sdt_recall))
    return(f1)
}

# calculate accuracy from 2x2 table
acc <- function(tab) {
    truepos <- tab[bindiag==1 & pred==1][,N]
    falsepos <- tab[bindiag==0 & pred==1][,N]
    falseneg <- tab[bindiag==1 & pred==0][,N]
    trueneg <- tab[bindiag==0 & pred==0][,N]
    if (length(truepos) == 0) { truepos<-0 }
    if (length(falsepos) == 0) { falsepos<-0 }
    if (length(falseneg) == 0) { falseneg<-0 }
    if (length(trueneg) == 0) { trueneg<-0 }
    
    acc <- (truepos + trueneg) / (truepos + trueneg + falsepos + falseneg)
    return(acc)
}


### K-FOLD CROSS VALIDATION

# https://stackoverflow.com/a/27626007/353278
chunk <- function(x, n) (mapply(function(a, b) (x[a:b]), seq.int(from=1, to=length(x), by=n), pmin(seq.int(from=1, to=length(x), by=n)+(n-1), length(x)), SIMPLIFY=FALSE))

numfolds <- 2
num_cycles <-  5000
f1_1 <- c()
f1_2 <- c()
f1_3 <- c()
acc_1 <- c()
acc_2 <- c()
acc_3 <- c()
results1_sum <- data.table()
results2_sum <- data.table()
results3_sum <- data.table()

for (cyclenum in seq(num_cycles)) {
    cat(cyclenum,"\n")
    # randomize ids
    nc_ss <- sample(dat[group=="NC",id])
    pad_ss <- sample(dat[group=="ProbAD",id])
    nc_samples <- chunk(nc_ss,length(nc_ss)/numfolds)
    pad_samples <- chunk(pad_ss,length(pad_ss)/numfolds)
    results1 <- data.table()
    results2 <- data.table()
    results3 <- data.table()
    for (sample_num in seq(numfolds)) {
        test_ids <- c(nc_samples[[sample_num]],pad_samples[[sample_num]])
        train_set <- dat[!(c(nc_ss,pad_ss) %in% test_ids)]
        test_set <- dat[id %in% test_ids]
        m1 <- glm(bindiag ~ educ + numtotal + persev_data, data=train_set, family=binomial(link="logit"))
        m2 <- glm(bindiag ~ numtotal + persev_data + mean_degree_diff + persev_params_unshuffled + diameter_diff, data=train_set, family=binomial(link="logit"))
        m3 <- glm(bindiag ~ educ+numtotal+persev_data+smallworld_unshuffled+number_of_nodes+density_unshuffled+mean_degree_unshuffled+spl_unshuffled+mean_degree_diff+spl_diff+persev_params_unshuffled+diameter_unshuffled+diameter_diff,data=dat,family=binomial(link="logit"))
        p1 <- round(predict(m1, newdata=test_set, type="response"))
        p2 <- round(predict(m2, newdata=test_set, type="response"))
        p3 <- round(predict(m3, newdata=test_set, type="response"))
        tab1 <- test_set[,.(bindiag, p1)]
        tab2 <- test_set[,.(bindiag, p2)]
        tab3 <- test_set[,.(bindiag, p3)]
        results1 <- rbind(results1, tab1)
        results2 <- rbind(results2, tab2)
        results3 <- rbind(results3, tab3)
    }
    results1 <- results1[,.N,keyby=.(bindiag,pred=p1)]
    results2 <- results2[,.N,keyby=.(bindiag,pred=p2)]
    results3 <- results3[,.N,keyby=.(bindiag,pred=p3)]
    results1_sum <- rbind(results1_sum,results1)
    results2_sum <- rbind(results2_sum,results2)
    results3_sum <- rbind(results3_sum,results3)

    f1_1 <- c(f1_1, fscore(results1))
    f1_2 <- c(f1_2, fscore(results2))
    f1_3 <- c(f1_3, fscore(results3))
    acc_1 <- c(acc_1, acc(results1))
    acc_2 <- c(acc_2, acc(results2))
    acc_3 <- c(acc_3, acc(results3))
    
}
results1 <- results1_sum[,sum(N)/num_cycles,keyby=.(bindiag,pred)]
results2 <- results2_sum[,sum(N)/num_cycles,keyby=.(bindiag,pred)]
results3 <- results3_sum[,sum(N)/num_cycles,keyby=.(bindiag,pred)]

### MMSE PLOTS

#  + persev_data?
# all correlations p < .001 (uncorrected)
a <- ggplot(dat,aes(y=mmse,x=smallworld_unshuffled, color=group)) + geom_point() + theme_classic() + theme(legend.position="none") + ylab("MMSE") + xlab("Small-world-ness") + theme(axis.title.x = element_text(size=rel(0.8))) + scale_color_manual(values=c("#1f78b4","#b2df8a"))
b <- ggplot(dat,aes(y=mmse,x=number_of_nodes, color=group)) + geom_point() + theme_classic() + theme(legend.position="none") + ylab("MMSE") + xlab("Number of nodes") + theme(axis.title.x = element_text(size=rel(0.8))) + scale_color_manual(values=c("#1f78b4","#b2df8a"))
c <- ggplot(dat,aes(y=mmse,x=density_unshuffled, color=group)) + geom_point() + theme_classic() + theme(legend.position="none") + ylab("MMSE") + xlab("Density") + theme(axis.title.x = element_text(size=rel(0.8))) + scale_color_manual(values=c("#1f78b4","#b2df8a"))
d <- ggplot(dat,aes(y=mmse,x=mean_degree_unshuffled, color=group)) + geom_point() + theme_classic() + theme(legend.position="none") + ylab("MMSE") + xlab("Mean degree") + theme(axis.title.x = element_text(size=rel(0.8))) + scale_color_manual(values=c("#1f78b4","#b2df8a"))
e <- ggplot(dat,aes(y=mmse,x=spl_unshuffled, color=group)) + geom_point() + theme_classic() + theme(legend.position="none") + ylab("MMSE") + xlab("Shortest-path length") + theme(axis.title.x = element_text(size=rel(0.8))) + scale_color_manual(values=c("#1f78b4","#b2df8a"))
f <- ggplot(dat,aes(y=mmse,x=numtotal, color=group)) + geom_point() + theme_classic() + theme(legend.position="none") + ylab("MMSE") + xlab("Avg number of responses") + theme(axis.title.x = element_text(size=rel(0.8))) + scale_color_manual(values=c("#1f78b4","#b2df8a"))
g <- ggplot(dat,aes(y=mmse,x=mean_degree_diff, color=group)) + geom_point() + theme_classic() + theme(legend.position="none") + ylab("MMSE") + xlab(Delta~"Mean degree") + theme(axis.title.x = element_text(size=rel(0.8))) + scale_color_manual(values=c("#1f78b4","#b2df8a"))
h <- ggplot(dat,aes(y=mmse,x=spl_diff, color=group)) + geom_point() + theme_classic() + theme(legend.position="none") + ylab("MMSE") + xlab(Delta~"Shortest-path length") + theme(axis.title.x = element_text(size=rel(0.8))) + scale_color_manual(values=c("#1f78b4","#b2df8a"))
i <- ggplot(dat,aes(y=mmse,x=persev_params_unshuffled, color=group)) + geom_point() + theme_classic() + theme(legend.position="none") + ylab("MMSE") + xlab(bquote(p[emit])) + theme(axis.title.x = element_text(size=rel(0.8))) + scale_color_manual(values=c("#1f78b4","#b2df8a"))
j <- ggplot(dat,aes(y=mmse,x=diameter_unshuffled, color=group)) + geom_point() + theme_classic() + theme(legend.position="none") + ylab("MMSE") + xlab("Diameter") + theme(axis.title.x = element_text(size=rel(0.8))) + scale_color_manual(values=c("#1f78b4","#b2df8a"))
k <- ggplot(dat,aes(y=mmse,x=diameter_diff, color=group)) + geom_point() + theme_classic() + theme(legend.position="none") + ylab("MMSE") + xlab(Delta~"Diameter") + theme(axis.title.x = element_text(size=rel(0.8))) + scale_color_manual(values=c("#1f78b4","#b2df8a"))
l <- ggplot(dat,aes(y=mmse,x=persev_data, color=group)) + geom_point() + theme_classic() + theme(legend.position="none") + ylab("MMSE") + xlab("Number of perseverations") + theme(axis.title.x = element_text(size=rel(0.7))) + scale_color_manual(values=c("#1f78b4","#b2df8a"))

#grid.arrange(a,b,c,d,e,f,g,h,i,j,k,l,nrow=4,ncol=4)
mmse_cor <- arrangeGrob(a,b,c,d,e,f,g,h,i,j,k,l,nrow=4,ncol=4)
#ggsave("mmse_cor.eps", mmse_cor)

rcorr(dat[group=="ProbAD",mmse],dat[group=="ProbAD",number_of_nodes]) #yes
rcorr(dat[group=="ProbAD",mmse],dat[group=="ProbAD",smallworld_unshuffled]) #yes
rcorr(dat[group=="ProbAD",mmse],dat[group=="ProbAD",density_unshuffled]) #yes
rcorr(dat[group=="ProbAD",mmse],dat[group=="ProbAD",numtotal]) #no
rcorr(dat[group=="ProbAD",mmse],dat[group=="ProbAD",mean_degree_unshuffled]) #no
rcorr(dat[group=="ProbAD",mmse],dat[group=="ProbAD",spl_unshuffled]) #no
rcorr(dat[group=="ProbAD",mmse],dat[group=="ProbAD",mean_degree_diff]) #no
rcorr(dat[group=="ProbAD",mmse],dat[group=="ProbAD",spl_diff]) #no
rcorr(dat[group=="ProbAD",mmse],dat[group=="ProbAD",persev_params_unshuffled]) #no
rcorr(dat[group=="ProbAD",mmse],dat[group=="ProbAD",persev_data]) #no
rcorr(dat[group=="ProbAD",mmse],dat[group=="ProbAD",diameter_unshuffled]) #no
rcorr(dat[group=="ProbAD",mmse],dat[group=="ProbAD",diameter_diff]) #no

#### PREDICTING DIAGNOSES

baseline_glm <- glm(bindiag ~ numtotal+persev_data+educ,data=dat,family=binomial(link="logit"))
maximal_glm <- glm(bindiag ~ educ+numtotal+persev_data+smallworld_unshuffled+number_of_nodes+density_unshuffled+mean_degree_unshuffled+spl_unshuffled+mean_degree_diff+spl_diff+persev_params_unshuffled+diameter_unshuffled+diameter_diff,data=dat,family=binomial(link="logit"))
stepmod_glm<-stepAIC(maximal_glm,direction="both")


### DEMOGRAPHICS

fluency_dat <- fread('ucsd_fluency_for_snafu_20180518.csv')
fluency_dat<-fluency_dat[group=="ProbAD" | group=="NC"]
fluency_dat<-fluency_dat[,.N,keyby=.(id,listnum)][,.(numlists=.N,avglistlength=mean(N)),keyby=id]

### CORRELATION MATRICES 

library(corrplot)
correl_mat <- dat[,.(numtotal,number_of_nodes,persev_data,persev_params_unshuffled,educ,density_unshuffled,density_diff,mean_degree_unshuffled,mean_degree_diff,spl_unshuffled,spl_diff,diameter_unshuffled,diameter_diff,smallworld_unshuffled)]
pmat <- rcorr(as.matrix(correl_mat))$P

correl_mat <- cor(correl_mat)
matnames <- c("Number of responses","Number of nodes","Persesveartion rate","$p[emit]","Years of education","Density",":Delta[Density]","Mean degree",":Delta[Meandegree]","ASPL",":Delta[ASPL]","Diameter",":Delta[Diameter]","Smallworld-ness")
rownames(correl_mat) <- matnames
colnames(correl_mat) <- matnames
         
corrplot(correl_mat,method="color",p.mat=pmat,tl.col="black",addCoef.col="black",number.cex=0.7)
